Index: trunk/SRC/ToBeReviewed/WIDGET/COMPOUND_WIDGET/cw_combobox_pm.pro
===================================================================
--- trunk/SRC/ToBeReviewed/WIDGET/COMPOUND_WIDGET/cw_combobox_pm.pro	(revision 148)
+++ trunk/SRC/ToBeReviewed/WIDGET/COMPOUND_WIDGET/cw_combobox_pm.pro	(revision 150)
@@ -1,100 +1,2 @@
-;------------------------------------------------------------
-;------------------------------------------------------------
-;------------------------------------------------------------
-;+
-; NAME: cw_combobox_pm
-;
-; PURPOSE: widget equivalent a WIDGET_COMBOBOX sauf qu'en plus on
-; dispose de 2 bouttons + et - pour deplacer le widget de +/- 1.
-;
-; CATEGORY: compound widget (aide a l''ecriture des widgets)
-;
-; CALLING SEQUENCE: id=cw_combobox_pm(parent)
-; 
-; INPUTS:
-;         Parent: The widget ID of the parent widget.
-;
-; KEYWORD PARAMETERS:tous ceux de WIDGET_COMBOBOX
-;
-; OUTPUTS:
-;         The returned value of this function is the widget ID of the
-;         newly-created animation widget.
-;
-; COMMON BLOCKS: none
-;
-; SIDE EFFECTS:
-;
-;     Widget Events Returned by Combobox Widgets
-;
-;   Pressing the mouse button while the mouse cursor is over an
-;   element of a combobox widget causes the widget to change the label
-;   on the combobox button and to generate an event. The appearance of
-;   any previously selected element is restored to normal at the same
-;   time. The event structure returned by the WIDGET_EVENT function is
-;   defined by the following statement:
-;
-;   { CW_COMBOBOX_PM, ID:0L, TOP:0L, HANDLER:0L, INDEX:0L, OUT:0 }
-;
-;   The first three fields are the standard fields found in every
-;   widget event.
-;   INDEX returns the index of the selected item. This can be used to
-;   index the array of names originally used to set the widget''s
-;   value
-;   OUT:c''est un entier qui peut prendre 3 valeurs:
-;       1 : si on appuie sur + alors que l''index est deja aux max. rq:
-;       ds ce cas l''index reste au max
-;       -1: si on appuie sur - alors que l''index est deja aux min. rq:
-;       ds ce cas l''index reste au min
-;       0 : ds les autres cas!
-;
-;   Keywords to WIDGET_CONTROL
-;
-;   A number of keywords to the WIDGET_CONTROL procedure affect the
-;   behavior of cw_slider_pm widget: GET_VALUE and SET_VALUE.
-;       1) GET_VALUE
-;   widget_control,wid_id,get_value=resultat
-;   retourne ds la variable resultat une structure de 3 elements dont
-;   les noms sont inspires des mots cles que l''on peut passer a
-;   widget_control qd on utilise WIDGET_COMBOBOX:
-;            COMBOBOX_NUMBER: the number of elements currently
-;            contained in the specified combobox widget.
-;            COMBOBOX_SELECT: the zero-based number of the
-;            currently-selected element (i.e., the currently-displayed
-;            element) in the specified combobox widget.
-;            DYNAMIC_RESIZE: a True value (1) if the widget specified
-;            by Widget_ID is a button, combobox, or label widget that
-;            has had its DYNAMIC_RESIZE attribute set. Otherwise,
-;            False (0) is returned.
-;       2) SET_VALUE
-;   widget_control,wid_id,set_value=impose
-;   permet de modifier l''etat de la combobox comme on peut le faire
-;   pour WIDGET_COMBOBOX Impose peut etre:
-;       a) The contents of the list widget (string or string array)
-;       b) une structure qui peut avoir comme elements (de 1 a 3):
-;            DYNAMIC_RESIZE:Set this keyword to activate (if set to 1)
-;            or deactivate (if set to 0) dynamic resizing of the
-;            specified CW_COMBOBOX_PM widget (see the documentation
-;            for the DYNAMIC_RESIZE keyword to WIDGET_COMBOBOX
-;            procedure for more information about dynamic widget
-;            resizing).
-;            COMBOBOX_SELECT:Set this keyword to return the zero-based
-;            number of the currently-selected element (i.e., the
-;            currently-displayed element) in the specified combobox
-;            widget.
-;            VALUE: The contents of the list widget (string or string
-;            array)
-;
-; RESTRICTIONS:
-;
-; EXAMPLE: cf utiliser le programme founit i-dessous: testwid et la
-; procedure associee, testwid_event.
-;
-; MODIFICATION HISTORY:Sebastien Masson (smasson@lodyc.jussieu.fr)
-;                      6/9/1999
-;
-;-
-;------------------------------------------------------------
-;------------------------------------------------------------
-;------------------------------------------------------------
 ; testwid, value=strtrim(indgen(10),2)
 ; PRO testwid_event, event
@@ -212,5 +114,118 @@
                   , INDEX:index, STR:cmbbtxt, OUT:out}
 end
-;----------------------------------------------------------------------
+;------------------------------------------------------------
+;------------------------------------------------------------
+;------------------------------------------------------------
+;+
+;
+; @file_comments
+; Like WIDGET_COMBOBOX but here, their are 2 buttons + and - to move the widget from +/- 1
+;
+; @categories
+; compound widget
+; 
+; @param PARENT {in}{required}
+; The widget ID of the parent widget.
+;
+; @keyword COLUMN
+; Buttons will be arranged in the number of columns
+; specified by this keyword.
+; 
+; @keyword ROW
+; Buttons will be arranged in the number of rows
+; specified by this keyword.
+; 
+; @keyword UVALUE
+; The user value to be associated with the widget.
+; 
+; @keyword UNAME
+; The user name to be associated with the widget.
+; 
+; @keyword VALUE
+;
+;
+; @keyword _EXTRA
+; Used to pass your keywords
+;
+; @returns
+; The returned value of this function is the widget ID of the
+; newly-created animation widget.
+;
+; @restrictions
+;
+;     Widget Events Returned by Combobox Widgets
+;
+;   Pressing the mouse button while the mouse cursor is over an
+;   element of a combobox widget causes the widget to change the label
+;   on the combobox button and to generate an event. The appearance of
+;   any previously selected element is restored to normal at the same
+;   time. The event structure returned by the WIDGET_EVENT function is
+;   defined by the following statement:
+;
+;   { CW_COMBOBOX_PM, ID:0L, TOP:0L, HANDLER:0L, INDEX:0L, OUT:0 }
+;
+;   The first three fields are the standard fields found in every
+;   widget event.
+;   INDEX returns the index of the selected item. This can be used to
+;   index the array of names originally used to set the widget''s
+;   value
+;   OUT:It is an integer which can take 3 values: 
+;       1 : If we press + when the index is already at the max
+;       Comment: In this case, the index stay at the max
+;       -1: If we press - when the index is already at the min
+;       Comment: In this case, the index stay at the min
+;       0 : In other cases
+;
+;   Keywords to WIDGET_CONTROL
+;
+;   A number of keywords to the WIDGET_CONTROL procedure affect the
+;   behavior of cw_slider_pm widget: GET_VALUE and SET_VALUE.
+;       1) GET_VALUE
+;   widget_control,wid_id,get_value=resultat
+;   Send back, in the result variable, a structure of 3 elements whose 
+;   names are inspired by keywords we can pass at widget_control when
+;   we use WIDGET_COMBOBOX:
+;            COMBOBOX_NUMBER: the number of elements currently
+;            contained in the specified combobox widget.
+;            COMBOBOX_SELECT: the zero-based number of the
+;            currently-selected element (i.e., the currently-displayed
+;            element) in the specified combobox widget.
+;            DYNAMIC_RESIZE: a True value (1) if the widget specified
+;            by Widget_ID is a button, combobox, or label widget that
+;            has had its DYNAMIC_RESIZE attribute set. Otherwise,
+;            False (0) is returned.
+;       2) SET_VALUE
+;   widget_control,wid_id,set_value=impose
+;   Allows to modify the state of the combobox like we can do it for 
+;   WIDGET_COMBOBOX. May impose: 
+;       a) The contents of the list widget (string or string array)
+;       b) A structure which can have for elements (from 1 to 3): 
+;            DYNAMIC_RESIZE:Set this keyword to activate (if set to 1)
+;            or deactivate (if set to 0) dynamic resizing of the
+;            specified CW_COMBOBOX_PM widget (see the documentation
+;            for the DYNAMIC_RESIZE keyword to WIDGET_COMBOBOX
+;            procedure for more information about dynamic widget
+;            resizing).
+;            COMBOBOX_SELECT:Set this keyword to return the zero-based
+;            number of the currently-selected element (i.e., the
+;            currently-displayed element) in the specified combobox
+;            widget.
+;            VALUE: The contents of the list widget (string or string
+;            array)
+;
+; @examples
+; See the program provided above (testwid and the associated procedure, testwid_event).
+;
+; @history
+; Sebastien Masson (smasson@lodyc.jussieu.fr)
+;                      6/9/1999
+;
+; @version
+; $Id$
+;
+;-
+;------------------------------------------------------------
+;------------------------------------------------------------
+;------------------------------------------------------------
 FUNCTION cw_combobox_pm, parent, VALUE = value, UVALUE = uvalue, UNAME = uname, ROW = row, COLUMN = column, _extra = ex
 ;
Index: trunk/SRC/ToBeReviewed/WIDGET/COMPOUND_WIDGET/cw_domain.pro
===================================================================
--- trunk/SRC/ToBeReviewed/WIDGET/COMPOUND_WIDGET/cw_domain.pro	(revision 148)
+++ trunk/SRC/ToBeReviewed/WIDGET/COMPOUND_WIDGET/cw_domain.pro	(revision 150)
@@ -53,5 +53,5 @@
    change = changegrid(currentgrid)
 ;------------------------------------------------
-; quel est le type de boxzoom?
+; What is the type of boxzoom ?
    currentplot = (extractatt(top_uvalue, 'smallin'))[2]-1
    options = extractatt(top_uvalue, 'options')   
@@ -63,5 +63,5 @@
     ytype = 'geographic' ELSE ytype = 'index'
 ;------------------------------------------------
-; comment completer la boxzoom?
+; How to complete the boxzoom ?
    IF xtype EQ  'geographic' then begin
       lonn1 = lon1
@@ -114,7 +114,7 @@
    strict = uvalue.strict
 ;
-; les longitudes
-;
-; min et max possible
+; Longitudes
+;
+; Possible min and max
    if xtype EQ 'geographic' then BEGIN
       min = floor(min([glamt,glamf], max = max))
@@ -124,16 +124,16 @@
       max = jpi-1
    ENDELSE
-; les id des widgets
+; widgets's id
    lon1id = widget_info(id,find_by_uname = 'lon1')
    lon2id = widget_info(id,find_by_uname = 'lon2')
-; doit-on changer de type d''axe x: longitude/index
+; Do we have to change the type of x axis: longitude/index
    lonbase = widget_info(id,find_by_uname = 'lonbase')
    widget_control, lonbase,  get_uvalue = lonbase_uvalue
    if lonbase_uvalue.name NE xtype then BEGIN
       widget_control, lonbase, update = 0
-; on casse tout
+; We break everything
       widget_control, lon1id, /destroy
       widget_control, lon2id, /destroy
-; on reconstruit
+; We reconstruct
       lon1id = cw_slider_pm(lonbase,value=min > boxzoom[0] < ((boxzoom[1] < max)-keyword_set(strict)) $
                             , uvalue={name:'lon1', strict:keyword_set(strict)},uname ='lon1' $
@@ -147,18 +147,18 @@
       widget_control, lonbase, update = 1
    ENDIF ELSE BEGIN
-; la nouvelle valeur qu''ils vont avoir
+; The new value  they will have
       cursorvalue1 = min > boxzoom[0] < ((boxzoom[1] < max)-strict)
       cursorvalue2 = ((min > boxzoom[0])+strict) > boxzoom[1] < max
-; on change les bornes des slider
+; We change slider's boundaries
       widget_control, lon1id, set_value = {slider_min:min, slider_max:cursorvalue2-strict}
       widget_control, lon2id, set_value = {slider_min:cursorvalue1+strict, slider_max:max}
-; on attribut la nouvelle valeur
+; We attribute the new value
       widget_control, lon1id , set_value = cursorvalue1
       widget_control, lon2id, set_value = cursorvalue2
    ENDELSE
 ;
-; les latitudes
-;
-; min et max possible
+; Latitudes
+;
+; Possible min and max
    if ytype EQ 'geographic' then begin
       min = floor(min([gphit,gphif], max = max))
@@ -168,5 +168,5 @@
       max = jpj-1
    ENDELSE
-; doit-on changer de type d''axe y: latitude/index
+; Do we have to change the type of y axis: latitude/index
    latbase = widget_info(id,find_by_uname = 'latbase')
    widget_control, latbase,  get_uvalue = latbase_uvalue
@@ -219,6 +219,5 @@
       widget_control, dthlv2id, set_value = {value:strtrim(gdep2, 1)}
    ENDIF ELSE gdep2 = gdep1+1
-; on s''assure que les profs donnees contiennent bien au moins un
-; niveau.
+; We make sure that given depthes contain at least one level.
    if boxzoom[4] GT boxzoom[5] then begin
       rien = boxzoom[4]
@@ -240,9 +239,9 @@
       boxzoom[5] = boxzoom[4]+1
    endif
-; maintenant que les values et les indexes sont definis proprement,
-; on peut les appliquer
+; Now, values and indexes are proprely defined.
+; So we can apply them
    widget_control, dthlv1id, set_value = {combobox_select:indice1}
    widget_control, dthlv2id, set_value = {combobox_select:indice2}
-; controler les min et les max des sliders...
+; control mins and maxs of sliders...
    if indice1 EQ 0 then min1 = 0 ELSE min1 = gdep2[indice1-1]
    max1 = (min1+1) > gdep1[indice2]
@@ -313,5 +312,5 @@
          depth2id = widget_info(event.handler,find_by_uname = 'depth2')
          dthlv2id = widget_info(event.handler,find_by_uname = 'dthlv2')
-; faut-il changer dthlv2 ?
+; Do we have to change dthlv2 ?
          widget_control, event.id, get_value = dthlv1_value
          gdep1 = fix(dthlv1_value.combobox_value)
@@ -319,7 +318,7 @@
          gdep2 = fix(dthlv2_value.combobox_value)
          if dthlv2_value.combobox_index LT event.index then BEGIN
-; on redefinie la valeur de dthlv2id
+; We redefine the dthlv2id's value
             widget_control, dthlv2id, set_value = {combobox_select:event.index}
-; donc on redefinit la valeur et le max du slider 2
+; So we redefine the value and the max of the slider 2
             if event.index EQ jpk-1 then BEGIN 
                max = max([gdept, gdepw])
@@ -329,11 +328,11 @@
             widget_control, depth2id $
              , set_value = {slider_max:max, value:gdep2[event.index]}
-; du coup on redefinie donc le max du slider 1 
+; So we redefine the max of the slider 1
             widget_control, depth1id, set_value = {slider_max:gdep1[event.index]}
          END 
-; on redefinie la valeur et le min du slider depth 1
+; We redefine the value and the min of the slider depth1 
          if event.index EQ 0 then min = 0 ELSE min = gdep1[event.index-1]+1
          widget_control, depth1id, set_value = {slider_min:min, value:gdep1[event.index]}
-; du coup on change aussi la valeur du min du slider depth 2
+; S we change the value of the min of the slider depth 2
          widget_control, depth2id, set_value = {slider_min:gdep1[event.index]+1}
       END
@@ -343,5 +342,5 @@
          depth2id = widget_info(event.handler,find_by_uname = 'depth2')
          dthlv1id = widget_info(event.handler,find_by_uname = 'dthlv1')
-; faut-il changer dthlv1 ?
+; Do we have to change dthlv1 ?
          widget_control, dthlv1id, get_value = dthlv1_value
          gdep1 = fix(dthlv1_value.combobox_value)
@@ -349,14 +348,14 @@
          gdep2 = fix(dthlv2_value.combobox_value)
          if dthlv1_value.combobox_index GT event.index then BEGIN
-; on redefinie la valeur de dthlv1id
+; We redfine the value of dthlv1id
             widget_control, dthlv1id, set_value = {combobox_select:event.index}
-; donc on redefinit la valeur et le min du slider 1
+; So we redefine the value and the min of the slider 1
             if event.index EQ 0 then min = 0 ELSE min = gdep2[event.index-1]
             widget_control, depth1id $
              , set_value = {slider_min:min, value:gdep1[event.index]}
-; du coup on redefinie donc le min du slider 2
+; Se we redefine the min of the slider 2
             widget_control, depth2id, set_value = {slider_min:gdep2[event.index]}
          END 
-; on redefinie la valeur et le max du slider depth 2
+; We redefine the value and the max of the slider depth 2
          if event.index EQ jpk-1 then BEGIN 
             max = max([gdept, gdepw])
@@ -365,5 +364,5 @@
          ENDIF ELSE max = gdep2[event.index+1]-1
          widget_control, depth2id, set_value = {slider_max:max, value:gdep2[event.index]}
-; du coup on change aussi la valeur du max du slider depth 1
+; So we change the value of the max of the slider depth 1
          widget_control, depth1id, set_value = {slider_max:gdep2[event.index]-1}
       END
@@ -372,5 +371,5 @@
          depth2id = widget_info(event.handler,find_by_uname = 'depth2')
          dthlv1id = widget_info(event.handler,find_by_uname = 'dthlv1')
-; doit-on changer dthlv1 ?
+; Do we have to change dthlv1 ?
          widget_control, dthlv1id, get_value = dthlv1_value
          gdep1 = fix(dthlv1_value.combobox_value)
@@ -378,9 +377,9 @@
          indice = indice < (jpk-1)
          if indice NE dthlv1_value.combobox_index then begin
-; on change le min de depth2
+; We change the min of depth2
             widget_control, depth2id, set_value = {slider_min:gdep1[indice]+1}
-; on redefinie la valeur de dthlv1id
+; We redefine the value of dthlv1id
             widget_control, dthlv1id, set_value = {combobox_select:indice}
-; donc on redefinit le min du slider 1
+; So we redefine the min of the slider 1
             if indice EQ 0 then min = 0 ELSE min = gdep1[indice-1]+1
             widget_control, event.id, set_value = {slider_min:min}
@@ -391,5 +390,5 @@
          depth1id = widget_info(event.handler,find_by_uname = 'depth1')
          dthlv2id = widget_info(event.handler,find_by_uname = 'dthlv2')
-; doit-on changer dthlv2 ?
+; Do we have to change dthlv2 ?
          widget_control, dthlv2id, get_value = dthlv2_value
          gdep2 = fix(dthlv2_value.combobox_value)
@@ -397,9 +396,9 @@
          indice = 0 > (indice-1)
          if indice NE dthlv2_value.combobox_index then begin
-; on change le max de depth1
+; We change the min of depth1
             widget_control, depth1id, set_value = {slider_max:gdep2[indice]-1}
-; on redefinie la valeur de dthlv2id
+; We redefine the value of dthlv2id
             widget_control, dthlv2id, set_value = {combobox_select:indice}
-; donc on redefinit le max du slider 2
+; So we redefine the min of the slider 2
             if indice EQ jpk-1 then BEGIN 
                max = max([gdept, gdepw])
@@ -418,4 +417,61 @@
 end
 ;*********************************************************************
+;+
+; @file_comments
+;
+;
+; @categories
+;
+; 
+; @param PARENT {in}{required}
+; The widget ID of the parent widget.
+; 
+; @keyword UVALUE
+; The user value to be associated with the widget.
+; 
+; @keyword UNAME
+; The user name to be associated with the widget.
+; 
+; @keyword STRICT
+;
+;
+; @keyword UNZOOM
+;
+;
+; @keyword BOXZOOM
+; Vector indicating the geographic zone on which we want to cut the map. 
+; If BOXZOOM has : 
+;   1 element : The extraction is made on [lon1, lon2, lat1, lat2, 0.,boxzoom[0]]
+;   2 elements: The extraction is made on [lon1, lon2, lat1, lat2, boxzoom[0],boxzoom[1]]
+;   4 elements: The extraction is made on [Boxzoom, 0, max([gdept, gdepw])]
+;   5 elements: The extraction is made on [Boxzoom[0:3], 0, Boxzoom[4]]
+;   6 elements: The extraction is made on Boxzoom 
+; Where lon1, lon2,lat1,lat2 are global variables defined at the last domdef!
+;
+; @keyword _EXTRA
+; Used to pass your keywords
+; 
+; @returns
+; 
+; 
+; @uses
+; 
+; 
+; @restrictions
+; 
+; 
+; @examples
+; 
+; 
+; @history
+; 
+; 
+; @version 
+; $Id$
+;
+; @todo
+; seb: Documenter
+; 
+;-
 FUNCTION cw_domain, parent, BOXZOOM = boxzoom, STRICT = strict, UVALUE = uvalue, UNAME = uname, UNZOOM = unzoom, _extra = ex
 ;
@@ -426,5 +482,5 @@
 @cm_4data
 ;
-; def de la boxzoom
+; Definition of the boxzoom
   Case N_Elements(Boxzoom) OF
     0:boxzoom = [lon1, lon2, lat1, lat2 $
Index: trunk/SRC/ToBeReviewed/WIDGET/COMPOUND_WIDGET/cw_droplist_pm.pro
===================================================================
--- trunk/SRC/ToBeReviewed/WIDGET/COMPOUND_WIDGET/cw_droplist_pm.pro	(revision 148)
+++ trunk/SRC/ToBeReviewed/WIDGET/COMPOUND_WIDGET/cw_droplist_pm.pro	(revision 150)
@@ -1,100 +1,2 @@
-;------------------------------------------------------------
-;------------------------------------------------------------
-;------------------------------------------------------------
-;+
-; NAME: cw_droplist_pm
-;
-; PURPOSE: widget equivalent a WIDGET_DROPLIST sauf qu'en plus on
-; dispose de 2 bouttons + et - pour deplacer le widget de +/- 1.
-;
-; CATEGORY: compound widget (aide a l''ecriture des widgets)
-;
-; CALLING SEQUENCE: id=cw_droplist_pm(parent)
-; 
-; INPUTS:
-;         Parent: The widget ID of the parent widget.
-;
-; KEYWORD PARAMETERS:tous ceux de WIDGET_DROPLIST
-;
-; OUTPUTS:
-;         The returned value of this function is the widget ID of the
-;         newly-created animation widget.
-;
-; COMMON BLOCKS: none
-;
-; SIDE EFFECTS:
-;
-;     Widget Events Returned by Droplist Widgets
-;
-;   Pressing the mouse button while the mouse cursor is over an
-;   element of a droplist widget causes the widget to change the label
-;   on the droplist button and to generate an event. The appearance of
-;   any previously selected element is restored to normal at the same
-;   time. The event structure returned by the WIDGET_EVENT function is
-;   defined by the following statement:
-;
-;   { CW_DROPLIST_PM, ID:0L, TOP:0L, HANDLER:0L, INDEX:0L, OUT:0 }
-;
-;   The first three fields are the standard fields found in every
-;   widget event.
-;   INDEX returns the index of the selected item. This can be used to
-;   index the array of names originally used to set the widget''s
-;   value
-;   OUT:c''est un entier qui peut prendre 3 valeurs:
-;       1 : si on appuie sur + alors que l''index est deja aux max. rq:
-;       ds ce cas l''index reste au max
-;       -1: si on appuie sur - alors que l''index est deja aux min. rq:
-;       ds ce cas l''index reste au min
-;       0 : ds les autres cas!
-;
-;   Keywords to WIDGET_CONTROL
-;
-;   A number of keywords to the WIDGET_CONTROL procedure affect the
-;   behavior of cw_slider_pm widget: GET_VALUE and SET_VALUE.
-;       1) GET_VALUE
-;   widget_control,wid_id,get_value=resultat
-;   retourne ds la variable resultat une structure de 3 elements dont
-;   les noms sont inspires des mots cles que l''on peut passer a
-;   widget_control qd on utilise WIDGET_DROPLIST:
-;            DROPLIST_NUMBER: the number of elements currently
-;            contained in the specified droplist widget.
-;            DROPLIST_SELECT: the zero-based number of the
-;            currently-selected element (i.e., the currently-displayed
-;            element) in the specified droplist widget.
-;            DYNAMIC_RESIZE: a True value (1) if the widget specified
-;            by Widget_ID is a button, droplist, or label widget that
-;            has had its DYNAMIC_RESIZE attribute set. Otherwise,
-;            False (0) is returned.
-;       2) SET_VALUE
-;   widget_control,wid_id,set_value=impose
-;   permet de modifier l''etat de la droplist comme on peut le faire
-;   pour WIDGET_DROPLIST Impose peut etre:
-;       a) The contents of the list widget (string or string array)
-;       b) une structure qui peut avoir comme elements (de 1 a 3):
-;            DYNAMIC_RESIZE:Set this keyword to activate (if set to 1)
-;            or deactivate (if set to 0) dynamic resizing of the
-;            specified CW_DROPLIST_PM widget (see the documentation
-;            for the DYNAMIC_RESIZE keyword to WIDGET_DROPLIST
-;            procedure for more information about dynamic widget
-;            resizing).
-;            DROPLIST_SELECT:Set this keyword to return the zero-based
-;            number of the currently-selected element (i.e., the
-;            currently-displayed element) in the specified droplist
-;            widget.
-;            VALUE: The contents of the list widget (string or string
-;            array)
-;
-; RESTRICTIONS:
-;
-; EXAMPLE: cf utiliser le programme founit i-dessous: testwid et la
-; procedure associee, testwid_event.
-;
-; MODIFICATION HISTORY:Sebastien Masson (smasson@lodyc.jussieu.fr)
-;                      6/9/1999
-;
-;-
-;------------------------------------------------------------
-;------------------------------------------------------------
-;------------------------------------------------------------
 ; PRO testwid_event, event
 ; ;   help, event, /STRUCT
@@ -199,4 +101,115 @@
 end
 ;----------------------------------------------------------------------
+;------------------------------------------------------------
+;------------------------------------------------------------
+;------------------------------------------------------------
+;+
+;
+; @file_comments
+; Like WIDGET_DROPLIST but here, their are 2 buttons + and - to move the widget from +/- 1
+;
+; @categories
+; compound widget
+; 
+; @param PARENT {in}{required}
+; The widget ID of the parent widget.
+;
+; @keyword COLUMN
+; Buttons will be arranged in the number of columns
+; specified by this keyword.
+; 
+; @keyword ROW
+; Buttons will be arranged in the number of rows
+; specified by this keyword.
+; 
+; @keyword UVALUE
+; The user value to be associated with the widget.
+; 
+; @keyword UNAME
+; The user name to be associated with the widget.
+; 
+; @keyword _EXTRA
+; Used to pass your keywords
+;
+; @returns
+; The returned value of this function is the widget ID of the
+; newly-created animation widget.
+;
+; @restrictions
+;
+;     Widget Events Returned by Droplist Widgets
+;
+;   Pressing the mouse button while the mouse cursor is over an
+;   element of a droplist widget causes the widget to change the label
+;   on the droplist button and to generate an event. The appearance of
+;   any previously selected element is restored to normal at the same
+;   time. The event structure returned by the WIDGET_EVENT function is
+;   defined by the following statement:
+;
+;   { CW_DROPLIST_PM, ID:0L, TOP:0L, HANDLER:0L, INDEX:0L, OUT:0 }
+;
+;   The first three fields are the standard fields found in every
+;   widget event.
+;   INDEX returns the index of the selected item. This can be used to
+;   index the array of names originally used to set the widget''s
+;   value
+;   OUT:It is an integer which can take 3 values: 
+;       1 : If we press + when the index is already at the max
+;       Comment: In this case, the index stay at the max
+;       -1: If we press - when the index is already at the min
+;       Comment: In this case, the index stay at the min
+;       0 : In other cases
+;
+;   Keywords to WIDGET_CONTROL
+;
+;   A number of keywords to the WIDGET_CONTROL procedure affect the
+;   behavior of cw_slider_pm widget: GET_VALUE and SET_VALUE.
+;       1) GET_VALUE
+;   widget_control,wid_id,get_value=resultat
+;   Send back, in the result variable, a structure of 3 elements whose 
+;   names are inspired by keywords we can pass at widget_control when
+;   we use WIDGET_COMBOBOX:
+;            DROPLIST_NUMBER: the number of elements currently
+;            contained in the specified droplist widget.
+;            DROPLIST_SELECT: the zero-based number of the
+;            currently-selected element (i.e., the currently-displayed
+;            element) in the specified droplist widget.
+;            DYNAMIC_RESIZE: a True value (1) if the widget specified
+;            by Widget_ID is a button, droplist, or label widget that
+;            has had its DYNAMIC_RESIZE attribute set. Otherwise,
+;            False (0) is returned.
+;       2) SET_VALUE
+;   widget_control,wid_id,set_value=impose
+;   permet de modifier l''etat de la droplist comme on peut le faire
+;   pour WIDGET_DROPLIST Impose peut etre:
+;       a) The contents of the list widget (string or string array)
+;       b) A structure which can have for elements (from 1 to 3): 
+;            DYNAMIC_RESIZE:Set this keyword to activate (if set to 1)
+;            or deactivate (if set to 0) dynamic resizing of the
+;            specified CW_DROPLIST_PM widget (see the documentation
+;            for the DYNAMIC_RESIZE keyword to WIDGET_DROPLIST
+;            procedure for more information about dynamic widget
+;            resizing).
+;            DROPLIST_SELECT:Set this keyword to return the zero-based
+;            number of the currently-selected element (i.e., the
+;            currently-displayed element) in the specified droplist
+;            widget.
+;            VALUE: The contents of the list widget (string or string
+;            array)
+;
+; @examples
+; See the program provided above (testwid and the associated procedure, testwid_event).
+;
+; @history
+; Sebastien Masson (smasson@lodyc.jussieu.fr)
+;                      6/9/1999
+;
+; @version
+; $Id$
+;
+;-
+;------------------------------------------------------------
+;------------------------------------------------------------
+;------------------------------------------------------------
 FUNCTION cw_droplist_pm, parent,UVALUE = uvalue, UNAME = uname, ROW = row, COLUMN = column, _extra = ex
 ;
Index: trunk/SRC/ToBeReviewed/WIDGET/COMPOUND_WIDGET/cw_pagelayout.pro
===================================================================
--- trunk/SRC/ToBeReviewed/WIDGET/COMPOUND_WIDGET/cw_pagelayout.pro	(revision 148)
+++ trunk/SRC/ToBeReviewed/WIDGET/COMPOUND_WIDGET/cw_pagelayout.pro	(revision 150)
@@ -18,14 +18,14 @@
 ;
 @common
-; si on ne change pas le nombre de colonnes, on sort
+; If we do not change the number of columns, we send
       if uval.name EQ 'column' then $
        if event.index+1 EQ smallin[0] THEN $
        return,{ID:event.handler, TOP:event.top, HANDLER:0L}
-; si on ne change pas le nombre de lignes, on sort
+; If we do not change the number of lines, we send
       if uval.name EQ 'row' then $
        if event.index+1 EQ smallin[1] THEN $
        return,{ID:event.handler, TOP:event.top, HANDLER:0L}
 ;
-; on efface la page
+; We erase the page
 ;      graphid = widget_info(event.top,find_by_uname = 'graph')
       graphid = extractatt(top_uvalue, 'graphid')
@@ -46,5 +46,5 @@
       nbredessin = smallin[0]*smallin[1]
 ;         
-; on remet tout a 0 en ce qui concerne les postscripts
+; We put all back to 0 for postscripts
       createhistory, event.top, smallin
 ;         
@@ -79,4 +79,58 @@
 end
 ;*********************************************************************
+;+
+; @file_comments
+;
+;
+; @categories
+;
+; 
+; @param PARENT {in}{required}
+; The widget ID of the parent widget.
+;
+; @param SMALL 
+;
+;
+; @keyword COLUMN
+; Buttons will be arranged in the number of columns
+; specified by this keyword.
+; 
+; @keyword ROW
+; Buttons will be arranged in the number of rows
+; specified by this keyword.
+; 
+; @keyword UVALUE
+; The user value to be associated with the widget.
+; 
+; @keyword UNAME
+; The user name to be associated with the widget.
+;
+; @keyword _EXTRA
+; Used to pass your keywords
+;
+; 
+; 
+; @returns
+; 
+; 
+; @uses
+; 
+; 
+; @restrictions
+; 
+; 
+; @examples
+; 
+; 
+; @history
+; 
+; 
+; @version
+; $Id$ 
+; 
+; @todo 
+; seb: documenter
+; 
+;-
 FUNCTION cw_pagelayout, parent, small, UVALUE = uvalue, UNAME = uname, UNZOOM = unzoom, COLUMN = column, ROW = row, _extra = ex
 ;------------------------------------------------
